program kaefer;
{$M 8192,0,655360}
uses crt,dos,graph,intuit,timer;

const xmax=24; ymax=16; dx=24; dy=24; ox=8; oy=8; maxkaefers=5;
      imafile  ='kaefer.ima';
      pal:array[0..15,0..2] of word=
      ((  0,0,0),(47,47,47), (31,31,31),(63,63,63),
       ( 42,  4,  4),( 57, 16, 17),( 63, 29, 31),(  0, 29, 32),
       (  0, 12, 59),( 18, 42, 59),( 20, 61, 38),( 31, 63,  0),
       ( 61, 10, 63),( 52, 39,  0),( 63, 63,  0),( 62, 63, 36));

type  feld =array[0..xmax,0..ymax] of integer;
      liste=array[0..xmax] of integer;
      kaef =record
                x,y,stx,sty,ri:integer;
             end;
      falter=record
                x,y,phase,ri:integer;
             end;

var ok,ende,kaefertot,feddich                     :boolean;
    ch                                            :char;
    ima                                           :array[0..28] of Image;
    igad                                          :array[1.. 5] of Gadget;
    xy1,xy2                                       :Koords;
    ibord1,ibord2                                 :Border;
    itext1,itext2                                 :array[1..5] of IntuiText;
    f,f0                                          :feld;
    maxfalters,level,ri,nkaefers,nfalters,ngoodies:integer;
    kaefers                                       :kaef;
    falters                                       :array[ 1..8] of falter;
    punkte                                        :longint;
    levelname                                     :string;

procedure getimages;
var i,j,k,anz:integer;
    fh   :file;
begin
assign(fh,imafile);
reset(fh,1);
BlockRead(fh,ima[0],sizeof(Image),anz);
with ima[0] do begin
   anz:=imagesize(1,1,width,height);
   GetMem(p_data,anz);
   BlockRead(fh,p_data^,anz,anz);
   putimage(0,0,p_data^,normalput);
end;
close(fh);
k:=0;
for i:=0 to 6 do for j:=0 to 3 do begin
   inc(k);
   with ima[k] do begin
      x:=0;
      y:=0;
      width:=dx;
      height:=dy;
      anz:=imagesize(1,1,width,height);
      GetMem(p_data,anz);
      GetImage(i*dx,j*dy,i*dx+pred(dx),j*dy+pred(dy),p_data^);
      p_nextimage:=nil;
   end;
end;
end;


procedure intuikram;
var i,j:integer;
begin
itext1[1].itext:='Hilfe';
itext1[2].itext:=' Neu ';
itext1[3].itext:=' Quit';
itext1[4].itext:='Level';
for i:=1 to 4 do begin
   with itext1[i] do begin
      x:=4;  y:=4; fpen:=3;  drmode:=jam1; bpen:=10;
      p_nexttext:=addr(itext2[i]);
   end;
   with itext2[i] do begin
      x:=3;  y:=4; fpen:=0;  drmode:=jam1; bpen:=10; itext:=itext1[i].itext;
      p_nexttext:=nil;
   end;
end;
xy1[0]:=0; xy1[1]:=14; xy1[2]:=0;  xy1[3]:=0;  xy1[4]:=47; xy1[5]:=0;
xy2[0]:=0; xy2[1]:=15; xy2[2]:=47; xy2[3]:=15; xy2[4]:=47; xy2[5]:=1;
with ibord1 do begin
   x:=0; y:=0; fpen:=3; bpen:=15; ecken:=3;
   p_ecken:=addr(xy1); p_nextborder:=addr(ibord2);
end;
with ibord2 do begin
   x:=0; y:=0; fpen:=0; bpen:=15; drmode:=jam1; ecken:=3;
   p_ecken:=addr(xy2); p_nextborder:=nil;
end;
for i:=1 to 4 do with igad[i] do begin
   id:=i;
   x:=440+48*i;
   if i=4 then x:=8;
   y:=464;
   width:=48;
   height:=16;
   bpen:=15;
   p_loborder:=addr(ibord1);
   p_hiborder:=p_loborder;
   p_loimage:=nil;
   p_hiimage:=p_loimage;
   p_lointuitext:=addr(itext1[i]);
   p_hiintuitext:=p_lointuitext;
   gadgettyp:=Boolgadget;
   onoff:=false;
   active:=true;
   p_specialinfo:=nil;
   if i=4 then p_nextgadget:=nil else p_nextgadget:=addr(igad[succ(i)]);
end;
end;

procedure abblenden;
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   setpalette(i,0);
end;
end;

procedure aufblenden;
var i:integer;
begin
for i:=0 to 15 do setpalette(i,i);
end;


procedure zeichnescreen;
var temp:string;
begin
temp:='UJAs Kferstndchen';
rectfill(0,0,639,479,15);
rectfill(0,16,639,463,2);
setcolor(3); line(0,0,639,0);   line(0,464,639,464); outtextxy(81,4,temp);
setcolor(0); line(0,15,639,15); line(0,479,639,479); outtextxy(80,4,temp);
RefreshGadgets(addr(igad[1]));
end;

procedure updatpunkte(punk:longint);
var temp:string;
begin
punkte:=punkte+punk;
str(punkte:6,temp);
temp:='Punkte'+temp;
rectfill(0,448,12*dx+ox,463,15);
setcolor(3); outtextxy(17,452,temp);
setcolor(0); outtextxy(16,452,temp);
end;

procedure kanzeige(n:integer);
var i,j,k:integer;
begin
for i:=1 to 5 do if i<=n then putimage(ox+dx*i,416,ima[6].p_data^,normalput)
                         else putimage(ox+dx*i,416,ima[8].p_data^,normalput);
end;

procedure fanzeige(n:integer);
var i,j,k:integer;
begin
rectfill(320,416,639,463,2);
for i:=1 to n do putimage(320+i*dx,416,ima[7].p_data^,normalput);
end;


procedure zeichneelement(x,y,z:integer);
begin
case z of
  0..8: putimage(x*dx+ox,y*dy+oy,ima[20+z].p_data^,normalput);
     9: putimage(x*dx+ox,y*dy+oy,ima[19].p_data^,normalput);
    10: putimage(x*dx+ox,y*dy+oy,ima[17].p_data^,normalput);
    11: putimage(x*dx+ox,y*dy+oy,ima[18].p_data^,normalput);
    12: putimage(x*dx+ox,y*dy+oy,ima[1+kaefers.ri].p_data^,normalput);
    13..16: putimage(x*dx+ox,y*dy+oy,ima[9+falters[z-12].ri+4*falters[z-12].phase].p_data^,normalput);
end;
end;

procedure zeichnelevel;
var i,j:integer;  temp:string;
begin
   for i:=1 to xmax do for j:=1 to ymax do zeichneelement(i,j,f[i,j]);
   kanzeige(nkaefers);
   fanzeige(nfalters);
   rectfill(ox+12*dx,448,639,463,15);
   setcolor(3); outtextxy(ox+14*dx+1,452,levelname);
   setcolor(0); outtextxy(ox+14*dx,452,levelname);
   rectfill(64,468,127,476,15);
   str(level:2,temp);
   setcolor(3); outtextxy(65,468,temp);
   setcolor(0); outtextxy(64,468,temp);
end;

procedure initkaefers;
begin
with kaefers do begin
x:=stx;
y:=sty;
ri:=0;
f[x,y]:=12;
zeichneelement(x,y,f[x,y]);
end;
end;

procedure initlevel;
const code=' 12345678e#mKM';
var i,j,k:integer;
    ok   :boolean;
    temp :string;
    fh   :text;
begin
levelname:='I N T E R N';
for i:=1 to xmax do for j:=1 to ymax do f0[i,j]:=10;
str(level:2,temp);
if temp[1]=#32 then  temp[1]:='0';
temp:='kaefer.l'+temp;
nfalters:=0;
ngoodies:=0;

{$i-}
assign(fh,temp);
reset(fh);
if ioresult=0 then begin
readln(fh,levelname);
for j:=1 to ymax do begin
   readln(fh,temp);
   for i:=1 to length(temp) do begin
      f0[i,j]:=pos(temp[i],code)-1;
      case f0[i,j] of
      1..9: inc(ngoodies);
        12: with kaefers do begin
               ri:=0;
               x:=i; stx:=x;
               y:=j; sty:=y;
            end;
        13: begin
               inc(nfalters);
               with falters[nfalters] do begin
                  f0[i,j]:=12+nfalters;
                  phase:=0;
                  ri:=0;
                  x:=i;
                  y:=j;
               end;
            end;
         end; { case}
      end; {i}
end; {j}
close(fh);
end else level:=-1;
maxfalters:=nfalters;
f:=f0;
zeichnelevel;
end;


procedure kaeferweg;
begin
   dec(nkaefers);
   kaefertot:=nkaefers=0;
   kanzeige(nkaefers);
   if not kaefertot then initkaefers;
end;

procedure falterweg(nr:integer);
begin
   f[falters[nr].x,falters[nr].y]:=0;
   falters[nr]:=falters[nfalters];
   dec(nfalters);
   fanzeige(nfalters);
end;


procedure initfalter;
var i,j:integer;
begin
if nfalters<maxfalters  then begin
   i:=random(xmax)+1;
   j:=random(ymax)+1;
   if f[i,j]=0 then begin
      inc(nfalters);
      with falters[nfalters] do begin
         x:=i;
         y:=j;
         phase:=0;
         ri:=0;
      end;
      fanzeige(nfalters);
   end;
end;
end;




{ ====================================================================== }


procedure oben;
var i,y1:integer; durch:boolean;
begin
durch:=false;
with kaefers do begin 
   putimage(x*dx+ox,y*dy+oy,ima[1].p_data^,normalput);
   if f[x,y-1]>12 then begin  { in Motte gerast }
      for i:=1 to dy do putimage(x*dx+ox,y*dy+oy-i,ima[1].p_data^,normalput);
      f[x,y]:=0;
      dec(y);
      zeichneelement(x,y,f[x,y]);
      kaeferweg;
      kanzeige(nkaefers);
      durch:=true;
    end;

    if (f[x,y-1]>0) and (f[x,y-1]<10) then
    if f[x,y-2]=f[x,y-1] then begin { Goodie gefischt }
       durch:=true;
       if f[x,y-1]<9 then begin
          updatpunkte(50);
          ngoodies:=ngoodies-2;
       end else begin
          if nkaefers<maxkaefers then inc(nkaefers);
          kanzeige(nkaefers);
       end;
       getimage(x*dx+ox,(y-1)*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy),ima[0].p_data^);
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox,(y-1)*dy+oy-i,ima[0].p_data^,normalput);
       end;
       f[x,y]:=0;
       y:=pred(y);
       f[x,y]:=12;
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox,y*dy+oy-i,ima[1].p_data^,normalput);
       end;
       f[x,y]:=0;
       y:=pred(y);
       f[x,y]:=12;
    end;

    y1:=y;
    while not durch do begin   { Blcke schieben }

       repeat dec(y1) until (f[x,y1]=0) or (f[x,y1]=10) or (f[x,y1]>12);
       durch:=f[x,y1]=10;     { kein Move }

       if not durch then if f[x,y1]>12 then  { Test auf Mottenfang }
       if ((f[x,y1-1]=10) or (f[x,y1-1]=11)) and (f[x,y1+1]=11) then begin
          updatpunkte(500);
          falterweg(f[x,y1]-12);
          f[x,y1]:=0;
       end;

       if not durch then if f[x,y1]=0 then begin { normales Schieben }
          durch:=true;
          getimage(x*dx+ox,(y1+1)*dy+oy,
                   x*dx+ox+pred(dx),y*dy+oy+pred(dy),ima[0].p_data^);
          for i:=1 to dy do begin
             delay(6);
             putimage(x*dx+ox,(y1+1)*dy+oy-i,ima[0].p_data^,normalput);
          end;
          for i:=y1 to pred(y) do begin
             f[x,i]:=f[x,succ(i)];
             if f[x,i]>12 then falters[f[x,i]-12].y:=i;
          end;
          f[x,y]:=0;
          y:=pred(y);
       end;

    end; { while }
  end;
end;


{ ------------------------------------------------------------------------ }

procedure unten;
var i,y1:integer; durch:boolean;
begin
durch:=false;
with kaefers do begin 
   putimage(x*dx+ox,y*dy+oy,ima[3].p_data^,normalput);

   if f[x,y+1]>12 then begin  { in Motte gerast }
      for i:=1 to dy do putimage(x*dx+ox,y*dy+oy+i,ima[3].p_data^,normalput);
      f[x,y]:=0;
      inc(y);
      zeichneelement(x,y,f[x,y]);
      kaeferweg;
      kanzeige(nkaefers);
      durch:=true;
    end;

    if (f[x,y+1]>0) and (f[x,y+1]<10) then
    if f[x,y+2]=f[x,y+1] then begin { Goodie gefischt }
       durch:=true;
       if f[x,y+1]<9 then begin
          updatpunkte(50);
          ngoodies:=ngoodies-2;
       end else begin
          if nkaefers<maxkaefers then inc(nkaefers);
          kanzeige(nkaefers);
       end;
       getimage(x*dx+ox,y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(2*dy),ima[0].p_data^);
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox,y*dy+oy+i,ima[0].p_data^,normalput);
       end;
       f[x,y]:=0;
       y:=succ(y);
       f[x,y]:=12;
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox,y*dy+oy+i,ima[3].p_data^,normalput);
       end;
       f[x,y]:=0;
       y:=succ(y);
       f[x,y]:=12;
    end;

    y1:=y;
    while not durch do begin   { Blcke schieben }

       repeat inc(y1) until (f[x,y1]=0) or (f[x,y1]=10) or (f[x,y1]>12);
       durch:=f[x,y1]=10;     { kein Move }

       if not durch then if f[x,y1]>12 then  { Test auf Mottenfang }
       if ((f[x,y1+1]=10) or (f[x,y1+1]=11)) and (f[x,y1-1]=11) then begin
          updatpunkte(500);
          falterweg(f[x,y1]-12);
          f[x,y1]:=0;
       end;

       if not durch then if f[x,y1]=0 then begin { normales Schieben }
          durch:=true;
          getimage(x*dx+ox,y*dy+oy,
                   x*dx+ox+pred(dx),pred(y1*dy+oy),ima[0].p_data^);
          for i:=1 to dy do begin
             delay(6);
             putimage(x*dx+ox,y*dy+oy+i,ima[0].p_data^,normalput);
          end;
          for i:=y1 downto succ(y) do begin
             f[x,i]:=f[x,pred(i)];
             if f[x,i]>12 then falters[f[x,i]-12].y:=i;
          end;
          f[x,y]:=0;
          y:=succ(y);
       end;

    end; { while }
  end;
end;

{ ------------------------------------------------------------------------ }

procedure rechts;
var i,x1:integer; durch:boolean;
begin
durch:=false;
with kaefers do begin 
   putimage(x*dx+ox,y*dy+oy,ima[2].p_data^,normalput);

   if f[x+1,y]>12 then begin  { in Motte gerast }
      for i:=1 to dx do putimage(x*dx+ox+i,y*dy+oy,ima[2].p_data^,normalput);
      f[x,y]:=0;
      inc(x);
      zeichneelement(x,y,f[x,y]);
      kaeferweg;
      kanzeige(nkaefers);
      durch:=true;
    end;

    if (f[x+1,y]>0) and (f[x+1,y]<10) then
    if f[x+2,y]=f[x+1,y] then begin { Goodie gefischt }
       durch:=true;
       if f[x+1,y]<9 then begin
          updatpunkte(50);
          ngoodies:=ngoodies-2;
       end else begin
          if nkaefers<maxkaefers then inc(nkaefers);
          kanzeige(nkaefers);
       end;
       getimage(x*dx+ox,y*dy+oy,x*dx+ox+pred(2*dx),y*dy+oy+pred(dy),ima[0].p_data^);
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox+i,y*dy+oy,ima[0].p_data^,normalput);
       end;
       f[x,y]:=0;
       x:=succ(x);
       f[x,y]:=12;
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox+i,y*dy+oy,ima[2].p_data^,normalput);
       end;
       f[x,y]:=0;
       x:=succ(x);
       f[x,y]:=12;
    end;

    x1:=x;
    while not durch do begin   { Blcke schieben }

       repeat inc(x1) until (f[x1,y]=0) or (f[x1,y]=10) or (f[x1,y]>12);
       durch:=f[x1,y]=10;     { kein Move }

       if not durch then if f[x1,y]>12 then  { Test auf Mottenfang }
       if ((f[x1+1,y]=10) or (f[x1+1,y]=11)) and (f[x1-1,y]=11) then begin
          updatpunkte(500);
          falterweg(f[x1,y]-12);
          f[x1,y]:=0;
       end;

       if not durch then if f[x1,y]=0 then begin { normales Schieben }
          durch:=true;
          getimage(x*dx+ox,y*dy+oy,
                   pred(x1*dx+ox),y*dy+oy+pred(dy),ima[0].p_data^);
          for i:=1 to dx do begin
             delay(6);
             putimage(x*dx+ox+i,y*dy+oy,ima[0].p_data^,normalput);
          end;
          for i:=x1 downto succ(x) do begin
             f[i,y]:=f[pred(i),y];
             if f[i,y]>12 then falters[f[i,y]-12].x:=i;
          end;
          f[x,y]:=0;
          x:=succ(x);
       end;

    end; { while }
  end;
end;

{ ------------------------------------------------------------------------ }

procedure links;
var i,x1:integer; durch:boolean;
begin
durch:=false;
with kaefers do begin 
   putimage(x*dx+ox,y*dy+oy,ima[4].p_data^,normalput);

   if f[x-1,y]>12 then begin  { in Motte gerast }
      for i:=1 to dx do putimage(x*dx+ox-i,y*dy+oy,ima[4].p_data^,normalput);
      f[x,y]:=0;
      dec(x);
      zeichneelement(x,y,f[x,y]);
      kaeferweg;
      kanzeige(nkaefers);
      durch:=true;
    end;

    if (f[x-1,y]>0) and (f[x-1,y]<10) then
    if f[x-2,y]=f[x-1,y] then begin { Goodie gefischt }
       durch:=true;
       if f[x-1,y]<9 then begin
          updatpunkte(50);
          ngoodies:=ngoodies-2;
       end else begin
          if nkaefers<maxkaefers then inc(nkaefers);
          kanzeige(nkaefers);
       end;
       getimage(x*dx+ox-dx,y*dy+oy,x*dx+ox+pred(dx),y*dy+oy+pred(dy),ima[0].p_data^);
       for i:=1 to dy do begin
          delay(6);
          putimage(x*dx+ox-dx-i,y*dy+oy,ima[0].p_data^,normalput);
       end;
       f[x,y]:=0;
       x:=pred(x);
       f[x,y]:=12;
       for i:=1 to dx do begin
          delay(6);
          putimage(x*dx+ox-i,y*dy+oy,ima[4].p_data^,normalput);
       end;
       f[x,y]:=0;
       x:=pred(x);
       f[x,y]:=12;
    end;

    x1:=x;
    while not durch do begin   { Blcke schieben }

       repeat dec(x1) until (f[x1,y]=0) or (f[x1,y]=10) or (f[x1,y]>12);
       durch:=f[x1,y]=10;     { kein Move }


       if not durch then if f[x1,y]>12 then  { Test auf Mottenfang }
       if ((f[x1-1,y]=10) or (f[x1-1,y]=11)) and (f[x1+1,y]=11) then begin
          updatpunkte(500);
          falterweg(f[x1,y]-12);
          f[x1,y]:=0;
       end;
       if not durch then if f[x1,y]=0 then begin { normales Schieben }
          durch:=true;
          getimage(x1*dx+ox+dx,y*dy+oy,
                   x*dx+ox+pred(dx),y*dy+oy+pred(dy),ima[0].p_data^);
          for i:=1 to dx do begin
             delay(6);
             putimage((x1+1)*dx+ox-i,y*dy+oy,ima[0].p_data^,normalput);
          end;
          for i:=x1 to pred(x) do begin
             f[i,y]:=f[succ(i),y];
             if f[i,y]>12 then falters[f[i,y]-12].x:=i;
          end;
          f[x,y]:=0;
          x:=pred(x);
       end;

    end; { while }
  end;
end;



procedure faltermove;
var i,j,k:integer;
begin
for j:=0 to 1 do
for i:=1 to nfalters do with falters[i] do if x>0 then begin
   phase:=j;
   delay(5);
   zeichneelement(x,y,13);
end;
for j:=0 to 1 do
for i:=1 to nfalters do with falters[i] do if x>0 then begin
   ri:=random(6);
   phase:=j;
   delay(5);
   zeichneelement(x,y,13);
end;
for i:=1 to nfalters do with falters[i] do if x>0 then begin
   phase:=0;
   f[x,y]:=0;
   delay(5);
   zeichneelement(x,y,0);
   case ri of
   0: if (f[x,y-1]=0) or (f[x,y-1]=12) then  dec(y);
   1: if (f[x+1,y]=0) or (f[x+1,y]=12) then  inc(x);
   2: if (f[x,y+1]=0) or (f[x,y+1]=12) then  inc(y);
   3: if (f[x-1,y]=0) or (f[x-1,y]=12) then  dec(x);
   else ri:=0;
   end;
   f[x,y]:=12+i;
   zeichneelement(x,y,13);
   if (x=kaefers.x) and (y=kaefers.y) then  kaeferweg;
end;
end;




begin
initscreen(ok);

if ok then begin
   abblenden;
   getimages;
   intuikram;
   zeichnescreen;
   aufblenden;
   level:=0;
   punkte:=0;
   nkaefers:=3;

   while not ende do begin
      inc(level);
      initlevel;
      kanzeige(nkaefers);
      feddich:=false;
      while not (feddich or ende) do begin
         faltermove;
         if random(500)<1 then initfalter;
         if not kaefertot then begin
         ch:='.';
         while keypressed do ch:=readkey;
         delay(50);
         case ch of
               #72: oben;
               #75: links;
               #77: rechts;
               #80: unten;

         #27,'Q','q': ende:=true;
         'N','n'    : begin feddich:=true; punkte:=0; level:=0; end;
         'L','l'    : begin feddich:=true; punkte:=0; end;
         'H','h'    : ;
         'R','r'    : zeichnelevel;
         end;
         end;
         feddich:=feddich or (ngoodies<1);
      end;
   end;


end;


end.
